/*
 * SD-SPI Protocol Standard
 *
 * Copyright (C) 2010, Broadcom Corporation
 * All Rights Reserved.
 * 
 * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
 * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM
 * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
 *
 * $Id: sdspi.h,v 9.1.20.1 2008/05/06 22:59:19 Exp $
 */


#define SPI_START_M		BITFIELD_MASK(1)	
#define SPI_START_S		31
#define SPI_DIR_M		BITFIELD_MASK(1)	
#define SPI_DIR_S		30
#define SPI_CMD_INDEX_M		BITFIELD_MASK(6)	
#define SPI_CMD_INDEX_S		24
#define SPI_RW_M		BITFIELD_MASK(1)	
#define SPI_RW_S		23
#define SPI_FUNC_M		BITFIELD_MASK(3)	
#define SPI_FUNC_S		20
#define SPI_RAW_M		BITFIELD_MASK(1)	
#define SPI_RAW_S		19
#define SPI_STUFF_M		BITFIELD_MASK(1)	
#define SPI_STUFF_S		18
#define SPI_BLKMODE_M		BITFIELD_MASK(1)	
#define SPI_BLKMODE_S		19
#define SPI_OPCODE_M		BITFIELD_MASK(1)	
#define SPI_OPCODE_S		18
#define SPI_ADDR_M		BITFIELD_MASK(17)	
#define SPI_ADDR_S		1
#define SPI_STUFF0_M		BITFIELD_MASK(1)	
#define SPI_STUFF0_S		0

#define SPI_RSP_START_M		BITFIELD_MASK(1)	
#define SPI_RSP_START_S		7
#define SPI_RSP_PARAM_ERR_M	BITFIELD_MASK(1)	
#define SPI_RSP_PARAM_ERR_S	6
#define SPI_RSP_RFU5_M		BITFIELD_MASK(1)	
#define SPI_RSP_RFU5_S		5
#define SPI_RSP_FUNC_ERR_M	BITFIELD_MASK(1)	
#define SPI_RSP_FUNC_ERR_S	4
#define SPI_RSP_CRC_ERR_M	BITFIELD_MASK(1)	
#define SPI_RSP_CRC_ERR_S	3
#define SPI_RSP_ILL_CMD_M	BITFIELD_MASK(1)	
#define SPI_RSP_ILL_CMD_S	2
#define SPI_RSP_RFU1_M		BITFIELD_MASK(1)	
#define SPI_RSP_RFU1_S		1
#define SPI_RSP_IDLE_M		BITFIELD_MASK(1)	
#define SPI_RSP_IDLE_S		0


#define SDSPI_COMMAND_LEN	6	
#define SDSPI_START_BLOCK	0xFE	
#define SDSPI_IDLE_PAD		0xFF	
#define SDSPI_START_BIT_MASK	0x80
